----------------------------------------------------------------
-- 4-bit delta-sigma modulator
--
--   designed by K.Yoshizawa 080825
----------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity deltaSigma4 is
	port(	dIn    : in std_logic_vector(3 downto 0);		-- data input
		c      : in std_logic;				-- system clock
		nr     : in std_logic;				-- system reset
		modOut : out std_logic);				-- data output
end deltaSigma4;

architecture rtl of deltaSigma4 is
	signal sum  : std_logic_vector(4 downto 0);
	signal aReg : std_logic_vector(3 downto 0);
begin
	process(nr,c)
	begin
		if (nr = '0') then
			aReg   <= (others => '0');
			modOut <= '0';
		elsif (c'event and c = '1') then
			aReg   <= sum(3 downto 0);
			modOut <= sum(4);
		end if;
	end process;

	sum <= ('0' & aReg) + dIn;
end rtl;
